"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class BaseMetadataRetriever {
    constructor(org, tooling = false) {
        this.org = org;
        this.tooling = tooling;
        this.dataLoaded = false;
        this.cacheFileName = "";
    }
    setQuery(query) {
        this.query = query;
    }
    async getObjects() {
        let records = [];
        const conn = this.org.getConnection();
        let result;
        // Query the org
        if (this.tooling) {
            result = await conn.tooling.query(this.query);
        }
        else {
            result = await conn.query(this.query);
        }
        records.push(...result.records);
        while (!result.done) {
            result = await this.queryMore(result.nextRecordsUrl);
            records.push(...result.records);
        }
        return records;
    }
    async queryMore(url) {
        const conn = this.org.getConnection();
        let result;
        if (this.tooling) {
            result = await conn.tooling.queryMore(url);
        }
        else {
            result = await conn.queryMore(url);
        }
        return result;
    }
}
exports.default = BaseMetadataRetriever;
//# sourceMappingURL=baseMetadataRetriever.js.map