"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const metadataInfo_1 = require("../metadataInfo");
const lodash_1 = __importDefault(require("lodash"));
const baseMetadataRetriever_1 = __importDefault(require("./baseMetadataRetriever"));
const metadataFiles_1 = __importDefault(require("../metadataFiles"));
const QUERY = "Select Id, Name, DeveloperName, SobjectType from RecordType";
class RecordTypeRetriever extends baseMetadataRetriever_1.default {
    constructor(org) {
        super(org);
        this.org = org;
        super.setQuery(QUERY);
    }
    static getInstance(org) {
        if (!RecordTypeRetriever.instance) {
            RecordTypeRetriever.instance = new RecordTypeRetriever(org);
        }
        return RecordTypeRetriever.instance;
    }
    async getObjects() {
        if ((this.data === undefined || this.data.length == 0) &&
            !this.dataLoaded) {
            let objects = await super.getObjects();
            objects = objects.map(elem => {
                elem.FullName = elem.SobjectType + "." + elem.DeveloperName;
                if (elem.DeveloperName === "PersonAccount" &&
                    elem.SobjectType === "Account") {
                    elem.FullName = "PersonAccount" + "." + elem.DeveloperName;
                }
                return elem;
            });
            this.data = objects;
            this.dataLoaded = true;
        }
        return this.data;
    }
    async getrecordTypes() {
        return await this.getObjects();
    }
    async recordTypeExists(recordType) {
        let found = false;
        //Look first in project files
        if (!lodash_1.default.isNil(metadataInfo_1.METADATA_INFO.RecordType.components)) {
            found = metadataInfo_1.METADATA_INFO.RecordType.components.includes(recordType);
        }
        if (!found && !metadataFiles_1.default.sourceOnly) {
            //not found, check on the org
            let recordTypes = await this.getrecordTypes();
            let foundRecordType = recordTypes.find(rt => {
                return rt.FullName === recordType;
            });
            found = !lodash_1.default.isNil(foundRecordType);
        }
        return found;
    }
}
exports.default = RecordTypeRetriever;
//# sourceMappingURL=recordTypeRetriever.js.map