"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = __importDefault(require("lodash"));
const baseMetadataRetriever_1 = __importDefault(require("./baseMetadataRetriever"));
const QUERY = "Select Id, Name, LicenseDefinitionKey From UserLicense";
class UserLicenseRetriever extends baseMetadataRetriever_1.default {
    constructor(org) {
        super(org, false);
        this.org = org;
        super.setQuery(QUERY);
    }
    static getInstance(org) {
        if (!UserLicenseRetriever.instance) {
            UserLicenseRetriever.instance = new UserLicenseRetriever(org);
        }
        return UserLicenseRetriever.instance;
    }
    async getObjects() {
        if ((this.data === undefined || this.data.length == 0) &&
            !this.dataLoaded) {
            super.setQuery(QUERY);
            this.data = await super.getObjects();
            this.dataLoaded = true;
        }
        return this.data;
    }
    async getUserLicenses() {
        return await this.getObjects();
    }
    async userLicenseExists(license) {
        let licenses = await this.getUserLicenses();
        let foundLicense = licenses.find(aLicense => {
            return aLicense.Name === license;
        });
        return !lodash_1.default.isNil(foundLicense);
    }
}
exports.default = UserLicenseRetriever;
//# sourceMappingURL=userLicenseRetriever.js.map