"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@salesforce/core");
class SFPowerkit {
    static async getProjectDirectories() {
        if (!SFPowerkit.projectDirectories) {
            SFPowerkit.projectDirectories = [];
            const dxProject = await core_1.SfdxProject.resolve();
            const project = await dxProject.retrieveSfdxProjectJson();
            let packages = project.get("packageDirectories") || [];
            packages.forEach(element => {
                SFPowerkit.projectDirectories.push(element.path);
                if (element.default) {
                    SFPowerkit.defaultFolder = element.path;
                }
            });
        }
        return SFPowerkit.projectDirectories;
    }
    static async getDefaultFolder() {
        if (!SFPowerkit.defaultFolder) {
            await SFPowerkit.getProjectDirectories();
        }
        return SFPowerkit.defaultFolder;
    }
    static setDefaultFolder(defaultFolder) {
        SFPowerkit.defaultFolder = defaultFolder;
    }
    static async getConfig() {
        if (!SFPowerkit.pluginConfig) {
            const dxProject = await core_1.SfdxProject.resolve();
            const project = await dxProject.retrieveSfdxProjectJson();
            let plugins = project.get("plugins") || {};
            let sfpowerkitConfig = plugins["sfpowerkit"];
            SFPowerkit.pluginConfig = sfpowerkitConfig || {};
        }
        return SFPowerkit.pluginConfig;
    }
}
exports.SFPowerkit = SFPowerkit;
//# sourceMappingURL=sfpowerkit.js.map