"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const delay_1 = require("./delay");
async function checkRetrievalStatus(conn, retrievedId, isToBeLoggedToConsole = true) {
    let metadata_result;
    while (true) {
        await conn.metadata.checkRetrieveStatus(retrievedId, function (error, result) {
            if (error) {
                return console.error(error);
            }
            metadata_result = result;
        });
        if (metadata_result.done === "false") {
            if (isToBeLoggedToConsole)
                console.log(`Polling for Retrieval Status`);
            await delay_1.delay(5000);
        }
        else {
            //this.ux.logJson(metadata_result);
            break;
        }
    }
    return metadata_result;
}
exports.checkRetrievalStatus = checkRetrievalStatus;
//# sourceMappingURL=checkRetrievalStatus.js.map